'use strict';
var request = require('request');
var Q = require('q');
var URL = require('url');

var accessToken;
var apiEndpoint = 'api.deezer.com';
var protocol = 'https';

var deezer = module.exports = {};

var _get = function(path, params) {
    var done = Q.defer();
    var parsedUrl = URL.parse(path, true);
    parsedUrl.protocol = parsedUrl.protocol || protocol;
    parsedUrl.host = apiEndpoint;
    parsedUrl.search = null;
    parsedUrl.query.access_token = accessToken;
    var apiUrl = URL.format(parsedUrl);
    request(apiUrl, function(err, response, body) {
        if (!err && response.statusCode == 200) {
            done.resolve(JSON.parse(body))
        } else {
            done.reject(err);
        }
    })

    return done.promise;
}
deezer.setAccessToken = function(token) {
    accessToken = token;
}

deezer.get = function(url, params) {
    return _get(url, params);
}